Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 10463)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 10464)
@@ -219,7 +219,4 @@
       <DependentUpon>SlidingWindowDataView.cs</DependentUpon>
     </Compile>
-    <Compile Include="SymbolicDataAnalysisGenealogyGraphView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
     <Compile Include="TextualSymbolicDataAnalysisModelView.cs">
       <SubType>UserControl</SubType>
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicDataAnalysisGenealogyView.Designer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicDataAnalysisGenealogyView.Designer.cs	(revision 10463)
+++ 	(revision )
@@ -1,61 +1,0 @@
-﻿using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Visualization;
-using TGraph = HeuristicLab.EvolutionTracking.GenealogyGraph<HeuristicLab.EvolutionTracking.GenealogyGraphNode<HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>, HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>;
-using TVertex = HeuristicLab.EvolutionTracking.GenealogyGraphNode<HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  partial class SymbolicDataAnalysisGenealogyView {
-    /// <summary> 
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary> 
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Component Designer generated code
-
-    /// <summary> 
-    /// Required method for Designer support - do not modify 
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.genealogyGraphChart1 = new HeuristicLab.EvolutionTracking.Views.GenealogyGraphChart<TGraph, TVertex, ISymbolicExpressionTree>();
-      this.SuspendLayout();
-      // 
-      // genealogyGraphChart1
-      // 
-      this.genealogyGraphChart1.BackColor = System.Drawing.SystemColors.Control;
-      this.genealogyGraphChart1.Chart = new Chart(0, 0, genealogyGraphChart1.PreferredSize.Width, genealogyGraphChart1.PreferredSize.Height);
-      this.genealogyGraphChart1.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.genealogyGraphChart1.Location = new System.Drawing.Point(0, 0);
-      this.genealogyGraphChart1.LockGenealogy = false;
-      this.genealogyGraphChart1.Name = "genealogyGraphChart1";
-      this.genealogyGraphChart1.ScaleOnResize = true;
-      this.genealogyGraphChart1.SimpleLineages = false;
-      this.genealogyGraphChart1.Size = new System.Drawing.Size(150, 150);
-      this.genealogyGraphChart1.TabIndex = 0;
-      // 
-      // SymbolicDataAnalysisGenealogyView
-      // 
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
-      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.Controls.Add(this.genealogyGraphChart1);
-      this.Name = "SymbolicDataAnalysisGenealogyView";
-      this.ResumeLayout(false);
-
-    }
-
-    #endregion
-
-    private EvolutionTracking.Views.GenealogyGraphChart<TGraph, TVertex, ISymbolicExpressionTree> genealogyGraphChart1;
-  }
-}
Index: anches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicDataAnalysisGenealogyView.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/SymbolicDataAnalysisGenealogyView.cs	(revision 10463)
+++ 	(revision )
@@ -1,58 +1,0 @@
-﻿using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.MainForm;
-
-using TGraph = HeuristicLab.EvolutionTracking.GenealogyGraph
-                <
-                  HeuristicLab.EvolutionTracking.GenealogyGraphNode<HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree>,
-                  HeuristicLab.Encodings.SymbolicExpressionTreeEncoding.ISymbolicExpressionTree
-                >;
-
-namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
-  [View("SymbolicDataAnalysisGenealogyView")]
-  [Content(typeof(TGraph), IsDefaultView = false)]
-  public sealed partial class SymbolicDataAnalysisGenealogyView : ItemView {
-    public new TGraph Content {
-      get { return (TGraph)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public SymbolicDataAnalysisGenealogyView() {
-      InitializeComponent();
-    }
-
-    protected override void DeregisterContentEvents() {
-      // TODO: Deregister your event handlers here
-      base.DeregisterContentEvents();
-    }
-
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      // TODO: Register your event handlers here
-    }
-
-    #region Event Handlers (Content)
-    // TODO: Put event handlers of the content here
-    #endregion
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      if (Content == null) {
-        // TODO: Add code when content has been changed and is null
-      } else {
-        genealogyGraphChart1.GenealogyGraph = Content;
-        // TODO: Add code when content has been changed and is not null
-      }
-    }
-
-
-    protected override void SetEnabledStateOfControls() {
-      base.SetEnabledStateOfControls();
-      // TODO: Enable or disable controls based on whether the content is null or the view is set readonly
-    }
-
-    #region Event Handlers (child controls)
-    // TODO: Put event handlers of child controls here.
-    #endregion
-  }
-}
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisPopulationDiversityAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisPopulationDiversityAnalyzer.cs	(revision 10463)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Analyzers/SymbolicDataAnalysisPopulationDiversityAnalyzer.cs	(revision 10464)
@@ -159,5 +159,5 @@
         SimilarityParameter.ActualValue = new DoubleValue();
 
-        var comp = new SymbolicExpressionTreeNodeSimilarityComparer {
+        var comparer = new SymbolicExpressionTreeNodeSimilarityComparer {
           MatchConstantValues = MatchConstantValuesParameter.Value.Value,
           MatchVariableNames = MatchVariableNamesParameter.Value.Value,
@@ -169,5 +169,5 @@
           var op = new SymbolicDataAnalysisExpressionTreeSimilarityCalculator {
             CurrentSymbolicExpressionTree = tree,
-            SimilarityComparer = comp,
+            SimilarityComparer = comparer,
             MaximumTreeDepth = MaximumSymbolicExpressionTreeDepth.Value
           };
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 10463)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4.csproj	(revision 10464)
@@ -189,5 +189,4 @@
       <SubType>Code</SubType>
     </Compile>
-    <Compile Include="SymbolicDataAnalysisExpressionPruningOperator.cs" />
     <Compile Include="SlidingWindow\GenerationalSlidingWindowAnalyzer.cs" />
     <Compile Include="SlidingWindow\OffspringSelectionSlidingWindowAnalyzer.cs" />
@@ -198,4 +197,5 @@
     <Compile Include="SymbolGraph\FPGraph.cs" />
     <Compile Include="SymbolGraph\SymbolGraph.cs" />
+    <Compile Include="SymbolicDataAnalysisExpressionPruningOperator.cs" />
     <Compile Include="SymbolicDataAnalysisExpressionTreeMatching.cs" />
     <Compile Include="SymbolicDataAnalysisExpressionTreeSimilarityCalculator.cs" />
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SlidingWindow/SlidingWindowQualitiesAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SlidingWindow/SlidingWindowQualitiesAnalyzer.cs	(revision 10463)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SlidingWindow/SlidingWindowQualitiesAnalyzer.cs	(revision 10464)
@@ -92,6 +92,5 @@
 
       var problemData = (IRegressionProblemData)ProblemDataParameter.ActualValue;
-      var evaluator =
-        (SymbolicDataAnalysisSingleObjectiveEvaluator<IRegressionProblemData>)EvaluatorParameter.ActualValue;
+      var evaluator = (SymbolicDataAnalysisSingleObjectiveEvaluator<IRegressionProblemData>)EvaluatorParameter.ActualValue;
       var context = new Core.ExecutionContext(ExecutionContext, evaluator, new Scope());
       var fitnessCalculationPartition = FitnessCalculationPartitionParameter.ActualValue;
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionPruningOperator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionPruningOperator.cs	(revision 10463)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionPruningOperator.cs	(revision 10464)
@@ -142,8 +142,7 @@
 
         quality -= impactValue;
+
         prunedSubtrees++;
       }
-
-      //      Quality.Value = quality; // update quality according to what has been pruned
 
       if (prunedSubtrees > 0) prunedTrees = 1;
@@ -160,5 +159,4 @@
     }
     protected abstract ISymbolicDataAnalysisModel CreateModel();
-    protected abstract double Evaluate();
     protected abstract double Evaluate(IDataAnalysisModel model);
   }
Index: /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionTreeSimilarityCalculator.cs
===================================================================
--- /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionTreeSimilarityCalculator.cs	(revision 10463)
+++ /branches/HeuristicLab.EvolutionTracking/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionTreeSimilarityCalculator.cs	(revision 10464)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -42,30 +42,23 @@
       get { return (IScopeTreeLookupParameter<ISymbolicExpressionTree>)Parameters[SymbolicExpressionTreeParameterName]; }
     }
-
     public IValueParameter<ISymbolicExpressionTree> CurrentSymbolicExpressionTreeParameter {
       get { return (IValueParameter<ISymbolicExpressionTree>)Parameters[CurrentSymbolicExpressionTreeParameterName]; }
     }
-
     public ILookupParameter<BoolValue> MatchVariableNamesParameter {
       get { return (ILookupParameter<BoolValue>)Parameters[MatchVariablesParameterName]; }
     }
-
     public ILookupParameter<BoolValue> MatchVariableWeightsParameter {
       get { return (ILookupParameter<BoolValue>)Parameters[MatchVariableWeightsParameterName]; }
     }
-
     public ILookupParameter<BoolValue> MatchConstantValuesParameter {
       get { return (ILookupParameter<BoolValue>)Parameters[MatchConstantValuesParameterName]; }
     }
-
     public ILookupParameter<DoubleValue> SimilarityParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters[SimilarityValuesParmeterName]; }
     }
-
     public ISymbolicExpressionTree CurrentSymbolicExpressionTree {
       get { return CurrentSymbolicExpressionTreeParameter.Value; }
       set { CurrentSymbolicExpressionTreeParameter.Value = value; }
     }
-
     public SymbolicExpressionTreeNodeSimilarityComparer SimilarityComparer { get; set; }
 